
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/* to get pH/um, -> 10^-6 / 10^-12 -> 10^6, this can be done by simply
   changing Uo (and K) */

                                /* K is a constant used, Uo/96PI */
                                /* and Uo is Uo, what can I say? */
/*
#define K 4.1666666E-9   
#define Uo 1.256637E-6  
*/
#define K 4.166666666667E-3         
#define Uo 1.25663706144           



#define PI 3.14159265359        /* uhh, guess what this is */
#define hPI 1.5707963268        /* hPI is half PI (PI/2) */
#define FALSE 0
#define TRUE 1
#define SMALL 8.881784197E-16 	/* this is 2^-50 for ease in asm routine */

typedef struct seg {
   double xll;
   double yll;
   double xur;
   double yur;
   double area_r;
} seg;

typedef struct input_conductor {
   int cnum;
   double xll, yll, xur, yur;
   double lam2;
   int xnum, ynum;
   double xratio, yratio;
   int xtype, ytype;
   struct input_conductor *next;
} input_conductor;

typedef struct conductor {
   int cnum,i_start,i_end;
   double lam2;
   seg **segarray;
   struct conductor *next;
} conductor;

/*=================================================
       Global variables
***************************************************/
input_conductor *input_cond;   /* input conductor linked list */
conductor *cond_head;          /* final conductor linked list */
double **q_matrix;    /* 2-D array of double for the Q matrix */
double **s_matrix;    /* 2-D array of double for the S matrix */
FILE *fp;             /* input file */

extern void subdivide();
extern void fast_matrix_invert(double**, int);
extern void print_matrix(double**, long, long, char*);
extern void getinput();
extern void s_qreduce();
extern void qeval(long);
extern double P(seg*, seg*);
extern double cP();
extern double F(double, double);
extern int readline(char*);
extern void make_segs(input_conductor*, conductor*);
extern double R(int, double);
extern void printlist();
extern void printinputlist();

